<script setup lang="ts">
import type { Image } from "@/models/image";
import { getIdForImage, isEnterPressed, isSpacebarPressed } from "@/utils/dom";
import BaseButton from "@/components/BaseButton.vue";

const props = withDefaults(defineProps<{ image: Image; isSlide?: boolean }>(), {
  isSlide: false,
});
const emit = defineEmits<{
  (e: "deletion", id: string): void;
  (e: "slide-view", id: string): void;
}>();

function onImageClick() {
  emit("slide-view", props.image.id);
}

function onImageKeydown(e: KeyboardEvent) {
  if (e.target instanceof HTMLButtonElement) {
    return;
  }

  if (!isEnterPressed(e) && !isSpacebarPressed(e)) {
    return;
  }

  emit("slide-view", props.image.id);
}
</script>

<template>
  <div class="wrapper" @click="onImageClick" @keydown="onImageKeydown">
    <img
      :src="image.url"
      :alt="image.label"
      class="image"
      loading="lazy"
      :id="getIdForImage(image.id)"
      :tabindex="isSlide ? -1 : 0"
    />
    <p class="label" aria-hidden="true">
      {{ image.label }}
    </p>
    <BaseButton
      v-if="!isSlide"
      class="button"
      @click.stop="() => $emit('deletion', image.id)"
      :aria-controls="image.id"
    >
      Delete
    </BaseButton>
  </div>
</template>

<style lang="scss" scoped>
.wrapper,
.image {
  width: 100%;
  height: 100%;
}

.image {
  object-fit: cover;
  object-position: center;
  border-radius: var(--border-radius);
  background-color: var(--color-grey-lighter);
  color: var(--color-dark);
  display: grid;
  place-content: center;
  text-align: center;
  line-height: 1.25;

  &:focus {
    outline: none;
  }
}

.label,
.button {
  position: absolute;
  box-sizing: border-box;
  z-index: 1;
  height: 0;
  opacity: 0;
}

.label {
  position: absolute;
  inset: calc(100% - 7.5rem) 7.2rem 1.2rem 2.4rem;
  font-weight: 500;
  line-height: 1.2;
  hyphens: auto;
  color: var(--color-light);
  overflow: hidden;
  text-overflow: ellipsis;
  transition: height var(--transition-config), opacity var(--transition-config);
}

.button {
  position: absolute;
  top: 1.8rem;
  right: 1.8rem;
  font-size: 1.6rem;
  text-transform: lowercase;
  color: var(--color-alert);
  border-radius: 100rem;
  overflow: hidden;
  width: 6.8rem;
  height: 3.2rem;
  line-height: 0;
  background-color: unset;
  box-shadow: unset;

  &:hover,
  &:focus {
    transform: unset;
    outline: unset;
    text-decoration: underline;
    color: var(--color-primary);
  }
}

.wrapper {
  --border-radius: 1.6rem;

  position: relative;

  &::after {
    content: "";
    position: absolute;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    background-color: transparent;
    border-radius: var(--border-radius);
    transition: background-color var(--transition-config);
  }

  &:hover,
  &:focus,
  &:focus-within {
    &::after {
      background-color: var(--color-dim-image);
    }

    & .label,
    .button {
      opacity: 1;
    }

    & .label {
      height: unset;
    }

    & .button {
      padding: 0.6rem 1.6rem;
      outline: 1px solid currentcolor;
    }
  }
}
</style>
